package com.dp.usb_lableprintdemo;

import java.io.IOException;
import java.io.InputStream;

import com.dp.dp_usblist.USBFactory;

import android.app.Activity;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;

public class LablePrintActivity extends Activity {


	private Button bt_text,bt_barcode,bt_qr,bt_image,bt_cuttall,bt_cutting,bt_textimage,bt_printdemo1,bt_printdemo2;
	private USBFactory usbfactory;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_normal);
		usbfactory=MainActivity.usbfactory;
		bt_text=(Button)findViewById(R.id.bt_text);
		bt_barcode=(Button)findViewById(R.id.bt_barcode);
		bt_qr=(Button)findViewById(R.id.bt_qr);
		bt_image=(Button)findViewById(R.id.bt_image);
		bt_cuttall=(Button)findViewById(R.id.bt_cuttall);
		bt_cutting=(Button)findViewById(R.id.bt_cutting);
		bt_textimage=(Button)findViewById(R.id.bt_textimage);
		bt_printdemo1=(Button)findViewById(R.id.bt_printdemo1);
		bt_printdemo2=(Button)findViewById(R.id.bt_printdemo2);
		//打印文本
		bt_text.setOnClickListener(new OnClickListener() {			
			@SuppressWarnings("static-access")
			@Override
			public void onClick(View arg0) {
//				if(!usbfactory.Check_Paper())
//				{
//					Toast_Util.ToastString(getApplicationContext(),  R.string.printer_does_not_have_paper);
//					return;
//				}
				/**
				 * LableText 标签文本打印
				 * 第一个参数  X轴横向位移量
				 * 第二个参数  Y轴纵向位移量
				 * 第三个参数  字体大小 有效值1-6
				 * 第四个参数   是否旋转 0不旋转，1旋转90°
				 * 第五个参数   文本内容
				 */
				usbfactory.LabelBegin(576, 330);//先设置标签的宽度和高度		
				usbfactory.LableText(0, 0, 2, 0, "fdsfdsfsdfsd");
				usbfactory.LableText(0, 200, 1, 0, "fdsfdsfsdfsd");
				usbfactory.Labelend();//必须要有标签结束，否则不会打印
				usbfactory.PaperAllCut();
			}
		});
		
//		打印条码
		bt_barcode.setOnClickListener(new OnClickListener() {			
			@SuppressWarnings("static-access")
			@Override
			public void onClick(View arg0) {
//				if(!usbfactory.Check_Paper())
//				{
//					Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
//					return;
//				}
				/**
				 * LableBarcode 标签条形码打印
				 * 第一个参数  X轴横向位移量
				 * 第二个参数  Y轴纵向位移量
				 * 第三个参数  条码高度 有效值10-200
				 * 第四个参数   条码线条宽度，1-4
				 * 第五个参数  是否旋转 0不旋转，1旋转90°
				 * 第六个参数   条码文本内容，不能包含有中文字符。
				 */
				usbfactory.LabelBegin(576, 330);//先设置标签的宽度和高度	
				usbfactory.LableBarcode(0, 0, 42, 3, 0, "abfc-12345654645");
				usbfactory.LableBarcode(0, 60,100, 3, 0, "654");
				usbfactory.Labelend();//必须要有标签结束，否则不会打印
				usbfactory.PaperAllCut();
			}
		});
		//打印二维码
		bt_qr.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View arg0) {
//				if(!usbfactory.Check_Paper())
//				{
//					Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
//					return;
//				}
				/**
				 * LabelQRCode 标签二维码打印
				 * 第一个参数  X轴横向位移量
				 * 第二个参数  Y轴纵向位移量
				 * 第三个参数  二维码大小 有效值2-8
				 * 第四个参数   二维码文本内容
				 */
				usbfactory.LabelBegin(576, 330);		//先设置标签的宽度和高度			
				usbfactory.LabelQRCode(50, 5, 4,"中国深圳");
				usbfactory.Labelend();//必须要有标签结束，否则不会打印	
				usbfactory.LabelBegin(576, 330);				
				usbfactory.LabelQRCode(50, 7, 4,"中国厦门");
				usbfactory.Labelend();//必须要有标签结束，否则不会打印	
				usbfactory.PaperAllCut();
				
			}
		});
//		打印图片
		bt_image.setOnClickListener(new OnClickListener() {			
			@SuppressWarnings("static-access")
			@Override
			public void onClick(View arg0) {
//				if(!usbfactory.Check_Paper())//检查是否有纸
//				{
//					Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
//					return;
//				}
				/**
				 * LableImage 标签图片打印
				 * 第一个参数  X轴横向位移量
				 * 第二个参数  Y轴纵向位移量
				 * 第三个参数  图片大小最大范围不能超过标签纸的宽度，最大不能超过576,如果图片是800*400打印机会做等比例缩放处理到要打印图片的大小
				 * 第四个参数   bitmap图片
				 */
				Bitmap bm = getImageFromAssetsFile("1.jpg");
				if (null != bm) {					
					usbfactory.LabelBegin(576, 330);//先设置标签的宽度和高度	
					usbfactory.LableImage(50, 50, 380, bm);
					usbfactory.Labelend();//必须要有标签结束，否则不会打印
					usbfactory.PaperCut();
				}else {
					Toast_Util.ToastString(getApplicationContext(), R.string.no_printed_pictures);//没有打印图片
				}
			}
		});
		
		bt_textimage.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				/** LableTextImage 文本图片标签打印
				//第一个参数  X轴横向位移量
				//第二个参数  Y轴纵向位移量
				//第三个参数    打印图片宽度
				//第四个参数    字体大小
				//第五个参数    生成图片文本内容
				*/
				usbfactory.LabelBegin(576, 330);//先设置标签的宽度和高度	
				usbfactory.LableTextImage(0, 0, 200, 30, "中国人民");
				usbfactory.LableTextImage(0, 50, 200, 40,"中国人民");
				usbfactory.LableTextImage(0, 120, 200, 50,"中国人民");
				usbfactory.LableTextImage(0, 200, 576, 100,"中国人民");
				usbfactory.Labelend();//必须要有标签结束，否则不会打印
				usbfactory.PaperCut();
			}
		});
		bt_cutting.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				usbfactory.PaperAllCut();//半切
			}
		});
		bt_cuttall.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				usbfactory.PaperAllCut();//全切
			}
		});
		
		bt_printdemo1.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
//				if(!usbfactory.Check_Paper())
//				{
//					Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
//					return;
//				}
				testdemo();
				
//				usbfactory.LabelBegin(576, 420);//先设置标签的宽度和高度	
//				usbfactory.LableText(10,20,2,0,"极速物流");
//				usbfactory.LableText(470,20,2,0,"电子");
//				usbfactory.LableText(10,240,2,0,"广州-->");
//				usbfactory.LableText(470,240,2,0,"汽运");
//				usbfactory.LableText(10,300,1,0,"厦门");				
//				usbfactory.LableBarcode(50,90, 100, 2, 0, "123456789586-32-143-5");
//				usbfactory.LableText(440,300,1,0,"2018-08-18");
//				usbfactory.Labelend();//必须要有标签结束，否则不会打印
//				usbfactory.PaperCut();//半切
			}
		});
		bt_printdemo2.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
//				if(!usbfactory.Check_Paper())
//				{
//					Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
//					return;
//				}
				usbfactory.LabelBegin(576, 360);//先设置标签的宽度和高度	
				usbfactory.LabelQRCode(10, 35,7,"电 池");
//				usbfactory.LabelQRCode(10, 190,7,"电 池");
				usbfactory.LableText(350,10,11,0,"MC 1001");
				usbfactory.LableText(350,60,11,0,"电 池");
				usbfactory.LableText(350,110,11,0,"2018-8-18");
				usbfactory.LableText(350,160,11,0,"18:18:18");
				usbfactory.LableText(350,210,11,0,"STCP00000369");				
				usbfactory.LableText(350,260, 11, 0, "2018-8-28前有效");
				usbfactory.LableText(350,330,11,0,"LS 32006");
				usbfactory.Labelend();//必须要有标签结束，否则不会打印
				usbfactory.PaperCut();
				demo2();
			}
		});
		if(getactivit!=null)
		{
			getactivit.onbackactivity(this);
		}
	}
	
	private void demo2()
	{
		usbfactory.LabelBegin(576, 360);//先设置标签的宽度和高度	
		usbfactory.LabelQRCode(400, 15,4,"微信公众号");
		usbfactory.LabelQRCode(400, 190,4,"微信公众号");
		usbfactory.LableText(25,20,1,0,"产品名称：纯玛咖精华");
		usbfactory.LableText(25,60,1,0,"原料：XXX、XXX、 XXX、XXX");
		usbfactory.LableText(25,100,1,0,"保质期：6个月   重量：250g");
		usbfactory.LableText(25,140,1,0,"生成日期：2018年8月18日");
		usbfactory.LableText(25,180,1,0,"使用人群：XXX、XXX");				
		usbfactory.LableText(25,220, 1, 0, "加工方式：手工加工");
		usbfactory.LableText(25,260,1,0,"地址：广东省深圳市南山区科技园");
		usbfactory.LableText(25,290,1,0,"中路信息产业园XXXXX");
		usbfactory.Labelend();//必须要有标签结束，否则不会打印
		usbfactory.PaperCut();
	}
	
	private void demo3()
	{
		usbfactory.LabelBegin(384, 250);//先设置标签的宽度和高度	
		usbfactory.LabelQRCode(0, 25,5,"电 池");
		usbfactory.LableText(200,10,1,0,"MC 1001");
		usbfactory.LableText(200,40,1,0,"电 池");
		usbfactory.LableText(200,70,1,0,"2018-8-18");
		usbfactory.LableText(200,100,1,0,"18:18:18");
		usbfactory.LableText(200,130,1,0,"STCP00000369");				
		usbfactory.LableText(200,160, 1, 0, "2018-8-28前有效");
		usbfactory.LableText(200,190,1,0,"LS 32006");
		usbfactory.Labelend();//必须要有标签结束，否则不会打印
		usbfactory.PaperAllCut();
	}
	/**
	 * 打印测试页面
	 * @param v
	 */
	public void printtestpage(View v)
	{
		
		usbfactory.PrintTestPage();
	}
	
	/**
	 * 检查缺纸
	 * 
	 */
	@SuppressWarnings("static-access")
	public void checkpage(View v)
	{
		usbfactory.Check_Paper();
	}
	
	private void testdemo()
	{
		Bitmap bm = getImageFromAssetsFile("e.jpg");
		usbfactory.LabelBegin(576, 330);//先设置标签的宽度和高度	
		usbfactory.LabelQRCode(350, 50,5,"二维码内容");
		usbfactory.LableImage(50, 50, 200, bm);
		usbfactory.LableText(300,250,1,0,"设备编号：*******xxxx");
		usbfactory.LableText(300,280,1,0,"住户编号：*******xxxx");
		usbfactory.Labelend();//必须要有标签结束，否则不会打印
		usbfactory.PaperAllCut();
	}
	/**
	 * 从Assets中读取图片
	 */
	private Bitmap getImageFromAssetsFile(String fileName) {
		Bitmap image = null;
		AssetManager am = getResources().getAssets();
		try {
			InputStream is = am.open(fileName);
			image = BitmapFactory.decodeStream(is);
			is.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return image;

	}
	
	public void back(View v)
	{
		finish();
	}
	
	
	private static onGetActivit getactivit = null;
	
	public static void setOnGetActivit(onGetActivit mactivit){
		getactivit = mactivit;
	}
	
	public interface onGetActivit {
	    void onbackactivity(Activity at);
	}
}
